/*!
 * @file        main.c
 *
 * @brief       Main program body
 *
 * @version     V1.0.0
 *
 * @date        2025-01-01
 *
 * @attention
 *
 *  Copyright (C) 2025 Geehy Semiconductor
 *
 *  You may not use this file except in compliance with the
 *  GEEHY COPYRIGHT NOTICE (GEEHY SOFTWARE PACKAGE LICENSE).
 *
 *  The program is only for reference, which is distributed in the hope
 *  that it will be useful and instructional for customers to develop
 *  their software. Unless required by applicable law or agreed to in
 *  writing, the program is distributed on an "AS IS" BASIS, WITHOUT
 *  ANY WARRANTY OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the GEEHY SOFTWARE PACKAGE LICENSE for the governing permissions
 *  and limitations under the License.
 */

/* Includes ***************************************************************/
#include "main.h"
#include <stdio.h>
#include "bmp561_iwdt.h"
#include "bmp561_gpio.h"
#include "bmp561_sysctrl.h"

/* Private includes *******************************************************/

/* Private macro **********************************************************/

/* Private typedef ********************************************************/

/* Private variables ******************************************************/
volatile uint32_t feeddogTime = 0;

/* Private function prototypes ********************************************/
void IWDT_Init(void);
void GPIO_Init(void);

/* External variables *****************************************************/

/* External functions *****************************************************/

/*!
 * @brief   Main program
 *
 * @param   None
 *
 * @retval  None
 */
int main(void)
{
    GPIO_Reset();
    GPIO_Init();

    if (SYSCTRL_ReadResetFlag(SYSCTRL_RST_IWDT) == SET)
    {
        GPIO_SetBit(GPIO_PIN_3);
        SYSCTRL_ClearResetFlag(SYSCTRL_RST_IWDT);
    }

    BOARD_Delay_Config();

    IWDT_Init();

    while (1)
    {
        BOARD_Delay_Ms(400);
        if (feeddogTime++ <= 5)
        {
            IWDT_ConfigFunction(IWDT_FUNC_FEEDDOG);
        }
    }
}

/*!
 * @brief   IWDT initialization
 *
 * @param   None
 *
 * @retval  None
 */
void IWDT_Init(void)
{
    SYSCTRL_Unlock();
    SYSCTRL_EnableAPBPeriphBCGClock(SYSCTRL_APB_IWDT);
    SYSCTRL_EnableAPBPeriphWCGClock(SYSCTRL_APB_IWDT);
    SYSCTRL_Lock();

    /* Over time = 255 / (65KHz / 256) ≈ 1s */
    IWDT_ConfigFunction(IWDT_FUNC_UNLOCK);
    IWDT_ConfigPrescaler(IWDT_PS_8);
    
    IWDT_ConfigFunction(IWDT_FUNC_UNLOCK);
    IWDT_ConfigReload(0xFF);

    IWDT_ConfigFunction(IWDT_FUNC_ENABLE);
}

/*!
 * @brief   GPIO initialization
 *
 * @param   None
 *
 * @retval  None
 */
void GPIO_Init(void)
{
    GPIO_Config_T gpioConfig;

    SYSCTRL_Unlock();
    SYSCTRL_EnableAHBPeriphClock(SYSCTRL_AHB_GPIO);
    SYSCTRL_Lock();

    gpioConfig.speed = GPIO_OS_HIGH;
    gpioConfig.type = GPIO_OT_PP;
    gpioConfig.pullEn = DISABLE;
    gpioConfig.polarity = GPIO_POL_UP;
    gpioConfig.drive = GPIO_DS_HIGH;
    gpioConfig.pin = GPIO_PIN_3;
    gpioConfig.mode = GPIO_MODE_OUT;
    GPIO_Config(&gpioConfig);
    GPIO_ResetBit(GPIO_PIN_3);
}
